﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using 模拟鼠标操作;

namespace 画图
{
    public partial class Form1 : Form
    {
        #region 声明API

        [DllImport("USER32.DLL")]
        private static extern int mouse_event(int dwFlags, int dx, int dy, int cButtons, int dwExtraInfo);
        //移动鼠标 
        const int MOUSEEVENTF_MOVE = 0x0001;
        //模拟鼠标左键按下 
        const int MOUSEEVENTF_LEFTDOWN = 0x0002;
        //模拟鼠标左键抬起 
        const int MOUSEEVENTF_LEFTUP = 0x0004;
        //模拟鼠标右键按下 
        const int MOUSEEVENTF_RIGHTDOWN = 0x0008;
        //模拟鼠标右键抬起 
        const int MOUSEEVENTF_RIGHTUP = 0x0010;
        //模拟鼠标中键按下 
        const int MOUSEEVENTF_MIDDLEDOWN = 0x0020;
        //模拟鼠标中键抬起 
        const int MOUSEEVENTF_MIDDLEUP = 0x0040;
        //标示是否采用绝对坐标 
        const int MOUSEEVENTF_ABSOLUTE = 0x8000;

        [DllImport("USER32.DLL")]
        public static extern void keybd_event(byte bVk, byte bScan, int dwFlags, int dwExtraInfo);  //导入模拟键盘的方法 
        //TAB键
        const int VK_TAB = 0x9;
        //回车键
        const int VK_RETURN = 0xD;
        //模拟键盘按下
        const int WM_KEYDOWN = 0;
        //模拟键盘弹起
        const int WM_KEYUP = 2;
        [DllImport("USER32.DLL")]
        public static extern IntPtr FindWindow(string lpClassName, string lpWindowName);  //导入寻找windows窗体的方法
        #endregion
        public string picPath = @"H:\work_today\14-6-27\test4.png";
        bool[,] alreadyDraw;
        //bool[,] alreadyRead;
        Dictionary<Color, bool[,]> colorDict = new Dictionary<Color, bool[,]>();

        /// <summary>
        /// 黑白数组
        /// </summary>
        bool[,] PicBWArr;
        /// <summary>
        /// 有色数组
        /// </summary>
        Color[,] PicColorArr;

        int similar;
        int range;

        static int SH = Screen.PrimaryScreen.Bounds.Height;
        static int SW = Screen.PrimaryScreen.Bounds.Width;
        Size userSetPicSize;
        KeyboardHook kh;
        private void PaintBoolArr(bool[,] arr)
        {



            Bitmap bitmap = new Bitmap(arr.GetLength(0), arr.GetLength(1));
            Graphics g = Graphics.FromImage(bitmap);
            for (int x = 0; x < arr.GetLength(0); x++)
            {
                for (int y = 0; y < arr.GetLength(1); y++)
                {
                    if (arr[x, y])
                    {
                        //Console.WriteLine(x);
                        g.DrawLine(new Pen(Color.Black), x, y, x + 1, y + 1);
                    }

                }
            }
            //Bitmap b=new Bitmap()
            bitmap.Save(Guid.NewGuid().ToString() + ".jpg");
        }

        private void MouseMoveTo(int X, int Y)
        {
            mouse_event(MOUSEEVENTF_ABSOLUTE | MOUSEEVENTF_MOVE | MOUSEEVENTF_LEFTDOWN | MOUSEEVENTF_LEFTUP, X * 65536 / SW, Y * 65536 / SH, 0, 0);
            Thread.Sleep(5);
        }
        private void ChangeColor(Color color)
        {
            //1024*768:961,75
            //1280*1024:1010,90
            MouseMoveTo(1010, 110);
            MouseMoveTo(1010, 110);
            Thread.Sleep(290);

            for (int i = 0; i < 7; i++)
            {
                keybd_event(VK_TAB, 0, WM_KEYDOWN, 0);
                keybd_event(VK_TAB, 0, WM_KEYUP, 0);
            }
            SendKeys.SendWait(color.R.ToString());
            keybd_event(VK_TAB, 0, WM_KEYDOWN, 0);
            keybd_event(VK_TAB, 0, WM_KEYUP, 0);
            SendKeys.SendWait(color.G.ToString());
            keybd_event(VK_TAB, 0, WM_KEYDOWN, 0);
            keybd_event(VK_TAB, 0, WM_KEYUP, 0);
            SendKeys.SendWait(color.B.ToString());
            keybd_event(VK_RETURN, 0, WM_KEYDOWN, 0);
            keybd_event(VK_RETURN, 0, WM_KEYUP, 0);
            Thread.Sleep(270);

        }
        Color test;
        #region OldCode
        //private bool[,] CheckImageOFused(string path)
        //{
        //    Image origiPic = Image.FromFile(path);
        //    Bitmap resizedPic = new Bitmap(origiPic, int.Parse(this.textBox1.Text), int.Parse(this.textBox2.Text));
        //    bool[,] colorArr = new bool[resizedPic.Width, resizedPic.Height];
        //    return colorArr;
        //}
        /// <summary>
        /// 得到判断性数组
        /// </summary>
        /// <param name="path"></param>
        //private void CheckImageOFALL(string path)
        //{
        //    //Image origiPic = Image.FromFile(path);
        //    //Bitmap resizedPic = new Bitmap(origiPic, 400, 300);



        //} 
        #endregion
        /// <summary>
        /// 得到近似颜色
        /// </summary>
        /// <param name="color"></param>
        /// <returns></returns>
        private Color simRGB(Color color)
        {
//            test = Color.FromArgb(color.R / similar * similar, color.G / similar * similar, color.B / similar * similar);
            return Color.FromArgb(color.R / similar * similar, color.G / similar * similar, color.B / similar * similar);
            //int[] simRGB = new int[3];
            //simRGB[0] = color.R / similar * similar;
            //simRGB[1] = color.G / similar * similar;
            //simRGB[2] = color.B / similar * similar;
            //return simRGB;
        }
        //private Color[,] GetPixels(Bitmap bmp)
        //{

        //    int wide = bmp.Width;
        //    int height = bmp.Height;
        //    Color[,] colorArr = new Color[wide, height];

        //    Rectangle rect = new Rectangle(0, 0, wide, height);
        //    //将Bitmap锁定到系统内存中,获得BitmapData
        //    BitmapData srcBmData = srcBitmap.LockBits(rect,
        //              ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb);
        //    //位图中第一个像素数据的地址。它也可以看成是位图中的第一个扫描行
        //    System.IntPtr srcPtr = srcBmData.Scan0;
        //    //将Bitmap对象的信息存放到byte数组中
        //    int src_bytes = srcBmData.Stride * height;
        //    byte[] srcValues = new byte[src_bytes];
        //    //复制GRB信息到byte数组
        //    System.Runtime.InteropServices.Marshal.Copy(srcPtr, srcValues, 0, src_bytes);
        //    for (int i = 0; i < height; i++)
        //    {
        //        for (int j = 0; j < wide; j++)
        //        {
        //            //只处理每行中图像像素数据,舍弃未用空间
        //            //注意位图结构中RGB按BGR的顺序存储
        //            int k = 3 * j;

        //            if (srcValues[i * srcBmData.Stride + k + 2] >= 230)
        //            {
        //                boolArr[j, i] = false;//白
        //            }
        //            else
        //            {
        //                boolArr[j, i] = true;
        //            }
        //        }
        //    }
        //    //解锁位图
        //    srcBitmap.UnlockBits(srcBmData);
        //}

        /// <summary>
        /// 模拟人手轨迹算法
        /// </summary>
        /// <param name="x"></param>
        /// <param name="y"></param>
        private void exiten(int x, int y, bool[,] picBoolArr)
        {
//            MessageBox.Show(test.R.ToString());
            //Color inSim;
            //Color ckSim;
            for (int i = -range; i <= range; i++)
            {
                for (int j = 0; j <= range; j++)
                {
                    if (x + j >= 0 && x + j < userSetPicSize.Width && y + i >= 0 && y + i < userSetPicSize.Height && !alreadyDraw[x + j, y + i])
                    {
                        //alreadyRead[x + j, y + i] = true;
                        //inSim = simRGB(PicColorArr[x, y]);
                        //ckSim = simRGB(PicColorArr[x + j, y + i]);
                        ////flag = ColorfulInt[x, y].R == ColorfulInt[x + j, y + i].R && ColorfulInt[x, y].G == ColorfulInt[x + j, y + i].G && ColorfulInt[x, y].B == ColorfulInt[x + j, y + i].B;//颜色相同
                        //flag = inSim == ckSim;
                        //flag = true;
                        //Console.WriteLine(flag);
                        if (!alreadyDraw[x + j, y + i] && picBoolArr[x + j, y + i])
                        {
                            //Console.WriteLine(x + j + "\t" + y + i);
                            MouseMoveTo(x + j + int.Parse(this.txtPicLocX.Text), y + i + int.Parse(this.txtPicLocY.Text));
                            alreadyDraw[x + j, y + i] = true;
                            exiten(x + j, y + i, picBoolArr);
                        }
                    }
                }
            }
        }
        /// <summary>
        /// 主方法
        /// </summary>
        private void DrawImage()
        {
            
            userSetPicSize = new Size(int.Parse(this.txtPicSizeW.Text), int.Parse(this.txtPicSizeH.Text));
            Bitmap resizedPic = new Bitmap(Image.FromFile(picPath), userSetPicSize);
            //resizedPic.Save("resized.jpg");
            //MessageBox.Show("Test");
            alreadyDraw = new bool[resizedPic.Width, resizedPic.Height];
            //alreadyRead = new bool[resizedPic.Width, resizedPic.Height];
            PicColorArr = ImageHelper.CheckImageOfColor(resizedPic);
            PicBWArr = ImageHelper.CheckImageBlack(resizedPic);
            similar = int.Parse(this.txtSim.Text);
            range = int.Parse(this.txtRange.Text);

            AddPointToColorDict(resizedPic);

            foreach (var item in colorDict)
            {
                //MessageBox.Show(item.Key.ToString());
                ChangeColor(item.Key);
                for (int x = 0; x < PicBWArr.GetLength(0); x++)
                {
                    for (int y = 0; y < PicBWArr.GetLength(1); y++)
                    {
                        if (!alreadyDraw[x, y] && item.Value[x, y])
                        {
                            //Console.WriteLine(PicColorArr[x, y]);
                            //ChangeColor(PicColorArr[x, y]);
                            exiten(x, y, item.Value);
                        }

                    }
                }

            }
            PaintBoolArr(PicBWArr);
            //PaintBoolArr(alreadyRead);

            PaintBoolArr(alreadyDraw);
            MessageBox.Show("完成");
        }


        private void AddPointToColorDict(Bitmap bmp)
        {
            for (int i = 0; i < bmp.Width; i++)
            {
                for (int j = 0; j < bmp.Height; j++)
                {
                    if (PicBWArr[i, j])//只有颜色明显的点才画
                    {
                        Color similarColor = simRGB(bmp.GetPixel(i, j));
                        if (colorDict.ContainsKey(similarColor))
                        {
                            colorDict[similarColor][i, j] = true;//
                        }
                        else
                        {
                            colorDict.Add(similarColor, new bool[bmp.Width, bmp.Height]);
                        }
                    }
                }
            }
            //删除杂色
            DeleteVaricoloredColor(colorDict);
        }

        private void DeleteVaricoloredColor(Dictionary<Color, bool[,]> colorDict)
        {
            //List<Color> removeList = new List<Color>();
            //foreach (var item in colorDict)
            //{
            //    double count = 0;
            //    for (int x = 0; x < item.Value.GetLength(0); x++)
            //    {
            //        for (int y = 0; y < item.Value.GetLength(1); y++)
            //        {
            //            if (item.Value[x, y])
            //            {
            //                count++;
            //            }
            //        }
            //    }
            //    if (count < (item.Value.GetLength(0) * item.Value.GetLength(1)) * 0.005)
            //    {
            //        removeList.Add(item.Key);
                    
            //    }
            //}
            //foreach (var item in removeList)
            //{
            //    colorDict.Remove(item);
            //}
            
        }


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            kh = new KeyboardHook();
            kh.SetHook();
            kh.OnKeyDownEvent += kh_OnKeyDownEvent;
        }
        /// <summary>
        /// 退出热键
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void kh_OnKeyDownEvent(object sender, KeyEventArgs e)
        {
            if (e.KeyData == (Keys.B | Keys.Control | Keys.Alt))
            {
                Environment.Exit(0);

            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            picPath = txtPath.Text.Replace('"', ' ').Trim();
            Thread tDraw = new Thread(DrawImage);
            tDraw.Start();
        }

        private int cacl()
        {
            int i = 91 / 100 * 100;
            return i;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            MessageBox.Show(Convert.ToString(cacl()));

        }

        private void button3_Click(object sender, EventArgs e)
        {
            MessageBox.Show("图片大小：图片被缩放到的大小\n图片位置：以屏幕左上角为0,0，画矩形，结束的地方为图片左上角\n相似值：值为区间范围，在此区间内算同一颜色（值越小选颜色越频繁）\n递归范围：值越大越不像人的轨迹\n停止键ctrl+alt+b");
        }

        private void txtThreshold_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
