﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace 画图
{
    public static class ImageHelper
    {
        /// <summary>
        /// 得到数组包含像素色彩信息
        /// </summary>
        /// <param name="path"></param>
        /// <returns>包含图片像素信息的数组</returns>
        public static Color[,] CheckImageOfColor(Bitmap bmp)
        {

            //Color colorPX = new Color();
            Color[,] colorArr = new Color[bmp.Width, bmp.Height];


            for (int i = 0; i < bmp.Width; i++)
            {
                for (int j = 0; j < bmp.Height; j++)
                {
                    colorArr[i, j] = bmp.GetPixel(i, j);
                    //= Color.FromArgb(colorPX.R, colorPX.G, colorPX.B);//白
                }
            }
            return colorArr;
        }
        public static  bool[,] CheckImageBlack(Image image)
        {
            Bitmap srcBitmap = new Bitmap(image);
            int wide = srcBitmap.Width;
            int height = srcBitmap.Height;
            bool[,] boolArr = new bool[wide, height];

            Rectangle rect = new Rectangle(0, 0, wide, height);
            //将Bitmap锁定到系统内存中,获得BitmapData
            BitmapData srcBmData = srcBitmap.LockBits(rect,
                      ImageLockMode.ReadWrite, PixelFormat.Format24bppRgb);
            //位图中第一个像素数据的地址。它也可以看成是位图中的第一个扫描行
            IntPtr srcPtr = srcBmData.Scan0;
            //将Bitmap对象的信息存放到byte数组中
            int src_bytes = srcBmData.Stride * height;
            byte[] srcValues = new byte[src_bytes];
            //复制GRB信息到byte数组
            Marshal.Copy(srcPtr, srcValues, 0, src_bytes);
            for (int i = 0; i < height; i++)
            {
                for (int j = 0; j < wide; j++)
                {
                    //只处理每行中图像像素数据,舍弃未用空间
                    //注意位图结构中RGB按BGR的顺序存储
                    int k = 3 * j;

                    if (srcValues[i * srcBmData.Stride + k + 2] >= 250)
                    {
                        boolArr[j, i] = false;//白
                    }
                    else
                    {
                        boolArr[j, i] = true;
                    }
                }
            }
            //解锁位图
            srcBitmap.UnlockBits(srcBmData);
            return boolArr;
        }
    }
}
